<template lang="pug">
  centered
    z-step
      li.step-item(:class="{ 'active': currentTab == 'username' }")
        a.tooltip(data-tooltip="Choosing a username" @click="gotoTab('username')") Username
      li.step-item(:class="{ 'active': currentTab == 'profile' }")
        a.tooltip(data-tooltip="Describe yourself" @click="gotoTab('profile')") Profile
      li.step-item(:class="{ 'active': currentTab == 'preferences' }")
        a.tooltip(data-tooltip="Tune your experience to fit your interests" @click="gotoTab('preferences')") Preferences
    div.colmuns
      div.col-9.col-md-12.col-mx-auto
        actor-edit(ref="username" v-show="currentTab == 'username'")
        profile-edit(ref="profile" :showAll="false" v-show="currentTab == 'profile'")
        user-preferences(ref="preferences" :showAll="false" v-show="currentTab == 'preferences'")
    div.columns
      div.col-10.col-mx-auto.col-setup-next
        z-button(color="primary" :class="{ 'loading': loading }" @click="next" :disabled="!nextActivated")
          span(v-if="currentTab === lastTab") {{ $t('save') }} & {{ $t('finish') }}
          span(v-else) {{ $t('save') }} & {{ $t('continue') }}
</template>

<script>
/* eslint-disable */
import Centered from '~/components/sublayouts/Centered.vue'
import ActorEdit from '~/components/ActorEdit.vue'
import ProfileEdit from '~/components/ProfileEdit.vue'
import UserPreferences from '~/components/UserPreferences.vue'

import { mapGetters } from 'vuex'

export default {
  middleware: 'isAuth',
  components: {
    Centered,
    /**
     * Components used as tabs have to implement both 'valid' as
     * a computed property and 'next' as a method. They must be
     * added with a 'ref' attribute using the same name as their
     * tab name in this.tabs.
     */
    ActorEdit,
    ProfileEdit,
    UserPreferences
  },
  data() {
    return {
      tabs: ['username', 'profile', 'preferences'],
      tab: 'profile', // in case setup is done, we default to profile and prevent switching to username elsewhere
      loading: false,
      nextActivated: false
    }
  },
  computed: {
    ...mapGetters('user', ['isSetup']),
    currentTab() {
      return this.isSetup ? this.tab : 'username'
    },
    lastTab() {
      return this.tabs[this.tabs.length - 1]
    }
  },
  mounted() {
    this.$watch(
      () => {
        return {
          username: this.$refs.username.valid,
          profile: this.$refs.profile.valid,
          preferences: this.$refs.preferences.valid
        }
      },
      val => {
        this.nextActivated = val[this.currentTab]
      }
    )
  },
  methods: {
    async next() {
      // actioning the tab
      this.loading = true
      await this.$refs[this.currentTab].next()
      this.loading = false

      if (this.currentTab === this.lastTab) {
        // if the current tab is last one, we leave the setup
        this.$router.push(this.localePath('home'))
      } else if (this.isSetup) {
        this.tab = this.tabs[(this.tabs.indexOf(this.tab) + 1) % this.tabs.length]
      } else {
        this.$toast.error('You need to select a username first', {
          icon: 'warning'
        })
      }
    },
    gotoTab(tab) {
      if (this.isSetup || tab === this.currentTab) {
        if (tab !== 'username') {
          this.tab = tab
        } else if (tab === this.currentTab) {
        } else {
          this.$toast.error('You already have a username', {
            icon: 'warning'
          })
        }
      } else {
        this.$toast.error('You need to select a username first', {
          icon: 'warning'
        })
      }
    }
  }
}
</script>

<style scoped>
.col-setup-next {
  display: flex;
  justify-content: right;
}
</style>
